



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LightOJ 1058  平行四边形的判断定理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LightOJ 1058  平行四边形的判断定理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 16:53:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目大意：给你n个点，求这n个点最多能组成多少个平行四边形。</p>
<p>题目思路：这道题卡时间，而且卡内存。你要尽可能的想办法优化。</p>
<p>平行四边形的判定定理：</p>
<ol><li><div>两组对边分别平行的四边形是平行四边形（定义判定法）；</div></li>
<li><div>一组<a href="http://baike.baidu.com/view/3454270.htm" rel="external nofollow noreferrer">对边</a>平行且相等的四边形是平行四边形；</div></li>
<li><div>两组<a href="http://baike.baidu.com/view/3454270.htm" rel="external nofollow noreferrer">对边</a>分别相等的四边形是平行四边形；</div></li>
<li><div>两组对角分别相等的四边形是平行四边形（两组对边平行判定）；</div></li>
<li>对角线互相平分的四边形是平行四边形。</li></ol>
<p>这道题用定理5判断。</p>
<p>记录每条边的中点坐标，如果两个边的中点坐标相同，证明这两条边为一个平行四边形的两条对角线。</p>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;cstdio&gt;<br />
#include&lt;stdio.h&gt;<br />
#include&lt;cstdlib&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;queue&gt;<br />
#define INF 0x3f3f3f<br />
#define MAX 1000005

using namespace std;

struct node<br />
{<br />
    double midx,midy;<br />
    int x,y;<br />
}Map[MAX];

int cmp(node A,node B)<br />
{<br />
    if(A.midx != B.midx)<br />
        return A.midx &gt; B.midx;<br />
    return A.midy &gt; B.midy;<br />
}<br />
int main()<br />
{<br />
    int T,n,i,j,num=,k;<br />
    long long sum,cnt,q;<br />
    scanf("%d",&amp;T);<br />
    while(T--)<br />
    {<br />
        sum=;<br />
        cnt=;<br />
        scanf("%d",&amp;n);<br />
        for(i=;i&lt;=n;i++)<br />
        {<br />
            scanf("%d%d",&amp;Map[i].x,&amp;Map[i].y);<br />
        }

        for(i=;i&lt;=n;i++)<br />
        {<br />
            for(j=i+;j&lt;=n;j++)<br />
            {<br />
                Map[cnt].midx=(Map[i].x+Map[j].x)/2.0;<br />
                Map[cnt++].midy=(Map[i].y+Map[j].y)/2.0;<br />
            }<br />
        }

        sort(Map,Map+cnt,cmp);//为了后面的操作更省时，先排序

        i=;<br />
        k=;<br />
        q=;<br />
        while(i &lt; cnt)<br />
        {<br />
            if(Map[i].midx==Map[k].midx &amp;&amp; Map[i].midy==Map[k].midy &amp;&amp; k!=i)<br />
                {<br />
                    sum+=q;//新增加的边可以与之前的每一条拥有相同中点的边形成一个新的平行四边形<br />
                    q++;<br />
                }<br />
            else if(Map[i].midx!=Map[k].midx || Map[i].midy!=Map[k].midy)<br />
            {<br />
                k=i;<br />
                q=;<br />
            }<br />
            i++;<br />
        }<br />
        printf("Case %d: %lld\n",num++,sum);<br />
    }<br />
    return ;<br />
}</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlm4ye9.html">使用django开发博客过程记录4&mdash;&mdash;Category分类视图</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8km0e39.html">python的正则表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r0r449.html">Memcached&lpar;1&rpar;-----基本介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j201e8.html">ios中自定义cell 设置cell的分组结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m5rlpq.html">&lpar;六&rpar; 一起学 Unix 环境高级编程 &lpar;APUE&rpar; 之 进程控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k11k659.html">Hbase之使用多Get实例返回数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z2nk69.html">ural 1748 The Most Complex Number  和 丑数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn62y6q.html">Java 8 新特性概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/950jrlm8.html">什么是Bootstrap？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkrnpv8.html">mac 上node&period;js环境的安装与测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1j5349.html">spring security 学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/96034p39.html">Linux 小知识翻译 - 「cron」</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjo4j79.html">《Java大学教程》&mdash;第23章 Java网络编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2dpvo9.html">kubernetes  Helm-chart web UI添加</a>
		</li>
						<li><a href="https://www.batexi.com/a/q250vrvq.html">java 数据类型相关的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gj1oeq.html">vue生命周期探究（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd4nvj9.html">从零开始学 Web 之 Ajax（五）同步异步请求，数据格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jwj75q.html">GIT 远程仓库：添加远程库、从远程库克隆</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4g5oe9.html">vue定义全局方法  调用其他组件的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnglvxq.html">STL中 vector 和 list 一些特性</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93ypm0g8.html">&lpar;转&rpar;eclipse自动补全的设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jkok38.html">Modernizr  测试浏览器是否兼容相应属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gepl578.html">HttpModule的基本概念</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzmkgg8.html">tomcat 配置SSL</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yjodr8.html">C&plus;&plus; 中 delete 和 delete&lbrack;&rsqb; 的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jxj038.html">UIScrollView   加载多个view view还可以交换顺序（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mdrgm8.html">软件测试之&alpha;测试和Beta测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojd5oeq.html">深入理解HTTP协议（转） 浏览器和服务器如何通信&lpar;HTTP协议&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg41ym8.html">IoC容器Autofac正篇之类型注册&lpar;五&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zov4xnq.html">SharePoint2013 Set Value To PeoplePicker</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
